#!/usr/bin/python
# -*- coding: utf-8 -*-

##   Copyright 2010 Pierre-Nicolas <pnprog@tuxfamily.org>

##   File: gosp.py
##   This file is the main part of GoSP 0.01.03, a program for training
##   at go with GNU Go.
##   Author: Pierre-Nicolas <pnprog@tuxfamily.org>
##   Date: Sun, 21 Mar 2010 20:28:14 +0800
##   For more information, see http://gosp.tuxfamily.org/

##   GoSP is free software: you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, either version 3 of the License, or
##   (at your option) any later version.
##
##   GoSP is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
##
##   You should have received a copy of the GNU General Public License
##   along with GoSP.  If not, see <http://www.gnu.org/licenses/>.

# -*- coding:Utf-8 -*-

from sys import exit

try:from gosp_infos import *
except:
	print "File \"gosp_infos.py\" missing."
	exit()

try:import Tkinter as Tk
except:
	print "Can not import \"Tkinter\" module. Is \"python-tk\" installed?"
	exit()

try:from goban import goban
except:
	print "File \"goban.py\" missing."
	exit()

def launch():
	
	global ent
	
	try:size=int(ent.get())
	except:
		ent.delete(0, Tk.END)
		ent.insert(0, 19)
		return
	
	if not 7<= size <=19:
		ent.delete(0, Tk.END)
		ent.insert(0, 19)
		return
	
	main = Tk.Toplevel()
	
	
	frame=Tk.Frame(main)
	play_black_button= Tk.Button(frame,text="Play black")
	play_black_button.pack(side=Tk.LEFT)
	play_white_button= Tk.Button(frame,text="Play white")
	play_white_button.pack(side=Tk.LEFT)
	undo_button= Tk.Button(frame,text="Undo")
	undo_button.pack(side=Tk.LEFT)

	frame.pack()
	
	canvas = Tk.Canvas(main, height=600, width=600, bg = "#DCB363")
	go1=goban(canvas,size)
	canvas.pack(fill=Tk.BOTH,expand=1)
	
	go1.auto_answer = Tk.IntVar()
	go1.auto_answer.set(1)
	auto_answer_checkbutton = Tk.Checkbutton(frame, text="Auto answer", variable=go1.auto_answer)
	auto_answer_checkbutton.pack(side=Tk.LEFT)
	
	go1.one_color_go = Tk.IntVar()
	go1.one_color_go.set(0)
	one_color_go_checkbutton = Tk.Checkbutton(frame, text="One color go", variable=go1.one_color_go)
	one_color_go_checkbutton.pack(side=Tk.LEFT)
	
	
	endgame_button= Tk.Button(frame,text="EndGame")
	endgame_button.pack(side=Tk.LEFT)
	
	
	canvas.bind("<Configure>",go1.display)
	canvas.bind("<Button-1>",go1.button1) #add/remove black stone
	canvas.bind("<Button-3>",go1.button3) #add/remove white stone

	canvas.bind("<Button-2>",go1.button2)
	
	
	play_black_button.configure(command=go1.gnugo_play_black)
	play_white_button.configure(command=go1.gnugo_play_white)
	undo_button.configure(command=go1.undo)
	one_color_go_checkbutton.configure(command=go1.display)
	endgame_button.configure(command=go1.end_game)
launcher=Tk.Tk()

lb1= Tk.Label(launcher,text="Go Study Partner "+gosp_version)
lb1.pack()


separator1=Tk.Frame(launcher,width=300,height=20)
separator1.pack()



line=Tk.Frame(launcher)
line.pack()
lb2= Tk.Label(line,text="Goban size: ")
lb2.pack(side=Tk.LEFT)
ent=Tk.Entry(line,width=2,text="19")
ent.insert(0, 19)
ent.pack()

separator2=Tk.Frame(launcher,width=300,height=20)
separator2.pack()


start_button = Tk.Button(launcher, text="Start", command=launch)
start_button.pack()


launcher.mainloop()

