#!/usr/bin/python
# -*- coding: utf-8 -*-

##   Copyright 2010 Pierre-Nicolas <pnprog@tuxfamily.org>

##   File: gtp.py
##   This file is part of GoSP 0.01.03, a program for training
##   at go with GNU Go.
##   Author: Pierre-Nicolas <pnprog@tuxfamily.org>
##   Date: Sun, 21 Mar 2010 20:28:14 +0800
##   For more information, see http://gosp.tuxfamily.org/

##   GoSP is free software: you can redistribute it and/or modify
##   it under the terms of the GNU General Public License as published by
##   the Free Software Foundation, either version 3 of the License, or
##   (at your option) any later version.
##
##   GoSP is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##   GNU General Public License for more details.
##
##   You should have received a copy of the GNU General Public License
##   along with GoSP.  If not, see <http://www.gnu.org/licenses/>.

# -*- coding:Utf-8 -*-

import subprocess


class gtp():
	def __init__(self,command):
		self.c=1
		self.process=subprocess.Popen(command, stdin=subprocess.PIPE, stdout=subprocess.PIPE)
		self.size=0
	
	####low level function####
	def write(self,txt):
		self.process.stdin.write(str(self.c)+" "+txt+"\n")
		self.c+=1

	def readline(self,nb=2):
		answer=self.process.stdout.readline()
		while answer=="\n":
			answer=self.process.stdout.readline()
		return answer
	
	####hight level function####
	def boardsize(self,size=19):
		self.size=size
		self.write("boardsize "+str(size))
		answer=self.readline()
		if answer[0]=="=":return True
		else:return False
		
	def close(self):
		self.process.stdin.close()
	
	def reset(self):
		self.write("clear_board")
		answer=self.readline()
		if answer[0]=="=":return True
		else:return False

	def place_black(self,move):
		self.write("play black "+move)
		answer=self.readline()
		if answer[0]=="=":return True
		else:return False	
	
	def place_white(self,move):
		self.write("play white "+move)
		answer=self.readline()
		if answer[0]=="=":return True
		else:return False
	
	def play_black(self):
		self.write("genmove black")
		answer=self.readline()[:-1]
		try:
			return answer.split(" ")[1]
		except:
			print "Error while parsing GNUGO black answer:", answer
		
	def play_white(self):
		self.write("genmove white")
		answer=self.readline()[:-1]
		print answer
		try:
			return answer.split(" ")[1]
		except:
			print "Error while parsing GNUGO white answer:", answer
	
	def undo(self):
		self.write("undo")
		answer=self.readline()
		if answer[0]=="=":
			return True
		else:
			return False
	
	def show_board(self):
		self.write("showboard")
		answer=self.readline(3+self.size)[:-1]
		return answer[4:]
	
	def countlib(self,move):
		self.write("countlib "+move)
		answer=self.readline()
		return " ".join(answer.split(" ")[1:])
	
	def final_score(self):
		self.write("final_score")
		answer=self.readline()
		return " ".join(answer.split(" ")[1:])
	
	def final_status(self,move):
		self.write("final_status "+move)
		answer=self.readline()
		answer=answer[:-1]
		return " ".join(answer.split(" ")[1:])

